map = class()

function map:init(x, y, length, width, size, renderDist, grassRenderDist)
    self.length = length
    self.width = width
    self.size = size
    self.initX = x
    self.initY = y
    self.x = x
    self.y = y
    self.renderDist = renderDist
    self.grassRenderDist = grassRenderDist
    self.groundObjs = {asset.groundObjects.grass, asset.groundObjects.grass_2, asset.groundObjects.grass_3}
end

function map:draw()
    while self.y < self.length do
        while self.x < self.width do
            
            self.tilePos = vec2(self.x * self.length, self.y * self.width)
            --draw ground tile
            if math.sqrt((((self.tilePos.x -playerX) - WIDTH/2) ^ 2) + (((self.tilePos.y -playerY) - HEIGHT/2)^ 2)) < self.renderDist then
                sprite(asset.ground_grass, self.x * self.length, self.y * self.width, self.size, self.size)
            end
            --random grass
            math.randomseed((self.x + 1)* (self.y + 1))
            for i = 0, 10  do
                self.grassX = math.random(0, self.size)
                self.grassY = math.random(0, self.size)
                self.groundObjType = math.random(1, #self.groundObjs)
                self.grassPos = vec2(((self.x * self.length ) - self.size/2) + self.grassX, ((self.y * self.width) - self.size/2) + self.grassY)
                
                if math.sqrt((((self.grassPos.x -playerX) - WIDTH/2) ^ 2) + (((self.grassPos.y -playerY) - HEIGHT/2)^ 2)) < self.grassRenderDist then
                    sprite(self.groundObjs[self.groundObjType], self.grassPos.x, self.grassPos.y, 10)
                end
            end
            -- end of tile
            self.x = self.x + 1
        end
        self.x = self.initX
        self.y = self.y + 1
    end 
    self.y = self.initY
end
