UI = class()

function UI:init(x)
    --[[
    self.plusButton = 
    { 
        draw = function() 
            fill(67, 98)
            rect(WIDTH - 80, HEIGHT/6, 50, 50)
            fill(255, 98)
            text("+", WIDTH - 55, HEIGHT/6 + 25) 
        end,
        touched = function(touch)
            if touch.pos.x > WIDTH - 80 and touch.pos.y > HEIGHT/6 and touch.pos.x < (WIDTH - 80) + 50 and touch.pos.y < (HEIGHT/6)  + 50 and touch.state == BEGAN then
                zoom = zoom - 3
            end
        end
    }
    ]]
    self.zoomSlider = 
    { 
        draw = function(variables) 
            stroke(56, 138)
            strokeWidth(5)
            rectMode(CENTER)
            rect(WIDTH - 100, HEIGHT/6, 100, 10)
            variables.sliderPos = math.max(math.min(variables.sliderPos, WIDTH - 50), WIDTH - 150)
            ellipseMode(CENTER)
            fill(67, 236)
            ellipse(variables.sliderPos, HEIGHT/6, 50)
            fill(255, 98)
            text("-/+", variables.sliderPos, HEIGHT/6)
            zoom = (variables.sliderPos - (WIDTH - 50)) * -0.35
        end,
        touched = function(touch, variables)
            
            if touch.pos.x > variables.sliderPos - 50 and touch.pos.y > HEIGHT/6 - 50 and touch.pos.x < variables.sliderPos + 50 and touch.pos.y < (HEIGHT/6)  + 50 and touch.state == BEGAN and variables.touchVar == nil then
                variables.touchVar = touch.id
            end
            if variables.touchVar then
                if touches[variables.touchVar].state == ENDED then
                    variables.touchVar = nil
                else
                variables.sliderPos = touches[variables.touchVar].pos.x
                end
            end
        end,
        variables = 
        {
            touchVar = nil, 
            sliderPos = WIDTH - 100
        }
    }
end

function UI:draw()
    pushStyle()
    fontSize(20)
    strokeWidth(2)
    stroke(188, 128)
    self.zoomSlider.draw(self.zoomSlider.variables)
    popStyle()
end

function UI:touched(touch)
    self.zoomSlider.touched(touch, self.zoomSlider.variables)
end
