inventory = class()

function inventory:init(x, y, slots)
    self.x = x
    self.y = y
    self.slots = slots
    self.open = false
end

function inventory:draw()
    -- inventory
    if self.open then
        pushStyle()
        rectMode(CORNER)
        fill(38, 32, 23)
        stroke(0)
        strokeWidth(5)
        rect(WIDTH/2 - 100, HEIGHT/2 - 100, 200, 200)
        popStyle()
    end
    -- inventory button
    pushStyle()
    fill(55, 42, 28, 136)
    rectMode(CORNER)
    rect(WIDTH - 72, HEIGHT - 128, 64, 64)
    fill(0)
    textMode(CENTER)
    sprite(asset.documents.Trial.icons.backpack_icon, WIDTH - 45, HEIGHT - 100, 50)
    popStyle()
end

function inventory:touched(touch)
    if touch.pos.x > WIDTH - 72 and touch.pos.y > HEIGHT - 128 then
        if touch.state == BEGAN then
            self.open = not self.open
        end
    end
end
